// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// This is the file to include for access to the complete binary node
// template implementation

#include "bnadt.h"

// Simple binary tree node implementation
template <typename Key, typename Elem>
class BNode : public BinNode<Elem> {
private:
  Key k;                  // The node's key
  Elem it;                // The node's value
  BNode* lc;              // Pointer to left child
  BNode* rc;              // Pointer to right child

public:
  // Two constructors -- with and without initial values
  BNode() { lc = rc = NULL; }
  BNode(Key K, Elem e, BNode* l =NULL, BNode* r =NULL)
    { k = K; it = e; lc = l; rc = r; }
  ~BNode() {}             // Destructor

  // Functions to set and return the value and key
  Elem& val() { return it; }
  void setVal(const Elem& e) { it = e; }
  Key& key() { return k; }
  void setKey(const Key& K) { k = K; }

  // Functions to set and return the children
  inline BNode* left() const { return lc; }
  void setLeft(BinNode<Elem>* b) { lc = (BNode*)b; }
  inline BNode* right() const { return rc; }
  void setRight(BinNode<Elem>* b) { rc = (BNode*)b; }

  // Return true if it is a leaf, false otherwise
  bool isLeaf() { return (lc == NULL) && (rc == NULL); }
};
