// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// ADT for buffer pools using the message-passing style
class BufferPool {
public:
  // Copy "sz" bytes from "space" to position "pos" in the
  //   buffered storage.
  virtual void insert(void* space, int sz, int pos) = 0;

  // Copy "sz" bytes from position "pos" of the buffered
  //   storage to "space".
  virtual void getbytes(void* space, int sz, int pos) = 0;
};
