// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// This is file inludes all the pieces needed for sorted linked lists

// Include linked list node class, implemented with free lists
#include "linkFL.h"
#include "llist.h"

// Specialization code to derive a sorted linked list from the generic
// linked list definition
template <typename Key, typename Elem>
class SLList: protected LList<KVpair<Key,Elem> > {
public:
  SLList(int size=DefaultListSize) :
    LList<KVpair<Key,Elem> >(size) {}
  ~SLList() {}                  // Destructor

  // Redefine insert function to keep values sorted
  void insert(KVpair<Key,Elem>& it) { // Insert at right
    KVpair<Key,Elem> curr;
    for (movetoStart(); rightLength() > 0; next()) {
      curr = getValue();
      if(curr.key() > it.key())
        break;
    }
    LList<KVpair<Key,Elem> >::insert(it);
  }

  LList<KVpair<Key,Elem> >::clear;
  LList<KVpair<Key,Elem> >::remove;
  LList<KVpair<Key,Elem> >::movetoStart;
  LList<KVpair<Key,Elem> >::movetoEnd;
  LList<KVpair<Key,Elem> >::prev;
  LList<KVpair<Key,Elem> >::next;
  LList<KVpair<Key,Elem> >::leftLength;
  LList<KVpair<Key,Elem> >::rightLength;
  LList<KVpair<Key,Elem> >::movetoPos;
  LList<KVpair<Key,Elem> >::getValue;
};
